SystemOrganization addCategory: #Esse!

Morph subclass: #MyMorphs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Esse'!

!MyMorphs methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 10/11/2011 15:07'!
handleKeystroke: anEvent
| keyValue |
keyValue := anEvent keyValue.
keyValue = $= asciiValue
ifTrue: [self startStepping].
keyValue = $- asciiValue
ifTrue: [self stopStepping].! !

!MyMorphs methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 10/11/2011 15:49'!
initialize
super initialize.
color := Color red.
bounds := 0 @ 0 extent: (300 @ 100).
self position:( self position- (300@0)+(0@250)).
! !

!MyMorphs methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 10/11/2011 15:46'!
step
self position: self position+ (1 @ 0)! !

!MyMorphs methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 10/11/2011 15:50'!
stepTime
^ 30! !

Morph subclass: #Rect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Esse'!

!Rect methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 18:38'!
handleKeystroke: anEvent
| keyValue |
keyValue := anEvent keyValue.
keyValue = 30
ifTrue: [self position:  self position  - (0@1*Stage Speed). Stage DontMoov:(0@ -1*Stage Speed )].
keyValue = 28
ifTrue: [self position:  self position - (Stage Speed *1@0). Stage DontMoov:( Stage Speed * -1@0).].
keyValue = 31
ifTrue: [self position:  self position +(0@1* Stage Speed). Stage DontMoov:(0@ 1*Stage Speed )].
keyValue = 29
ifTrue: [self position:  self position +(Stage Speed *1@0). Stage DontMoov:(Stage Speed *1@0)].
! !

!Rect methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 19:07'!
initialize
super initialize.
color := Color red.
bounds := 50 @ 50 extent: (150 @ 150).! !

!Rect methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 19:14'!
step
	self changed! !

!Rect methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 19:14'!
stepTime
	^ 0! !

Morph subclass: #Stage
	instanceVariableNames: 'speed'
	classVariableNames: 'stage'
	poolDictionaries: ''
	category: 'Esse'!

!Stage class methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 02:48'!
Create
	^stage:= Stage new 
		
		yourself! !

!Stage class methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 02:49'!
DontMoov: aPoint
^stage Position: aPoint 
yourself ! !

!Stage class methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 03:10'!
Speed
^stage  speed 
! !

!Stage methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 03:40'!
Position: aPoint
self position: self position +aPoint ! !

!Stage methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 18:37'!
handleKeystroke: anEvent
| keyValue |
keyValue := anEvent keyValue.
keyValue = 30 "up arrow"
ifTrue: [self position:  self position  + (0@1*self speed )].
keyValue = 28 "left arrow" 
ifTrue: [self position:  self position +(self speed*1@0)].
keyValue = 31 "down arrow" 
ifTrue: [self position:  self position -(0@1*self speed)].
keyValue = 29 "right arrow" 
ifTrue: [self position:  self position -(self speed*1@0)].
keyValue = $, asciiValue
ifTrue: [ self speed >1 ifTrue:[speed:=self speed -1 ]].
keyValue = $. asciiValue
ifTrue: [speed:=self speed +1].! !

!Stage methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 19:12'!
initialize
super initialize.
color := Color green .
speed:=2 .
bounds := 10 @ 10 extent: (1700 @ 1700).! !

!Stage methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 18:48'!
speed
^speed! !

!Stage methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 18:48'!
speed:aSpeed 
speed:=aSpeed ! !

!Stage methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 18:46'!
step
	self changed! !

!Stage methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 18:46'!
stepTime
	^ 0! !

BorderedMorph subclass: #Arrow
	uses: TAbleToRotate
	instanceVariableNames: 'startarrow drow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Esse'!

Arrow class
	uses: TAbleToRotate classTrait
	instanceVariableNames: ''!

!Arrow methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 20:45'!
ArrowEndSize: aSize position: aPoint
	| bill |
	bill := ArrowEnd new color: self color.
	bill Size: aSize.
	bill position: self position + aPoint.
	bill openInWorld.
	startarrow addMorph: bill! !

!Arrow methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 22:17'!
Start
 startarrow:=ArrowEnd  new color: self color.startarrow  Size: 0@0 . startarrow   position: self position .startarrow  openInWorld.    self addMorph: startarrow    .! !

!Arrow methodsFor: 'accessing' stamp: 'ArtyomSemikov 11/20/2011 21:26'!
borderWidth: anInteger
	"Grow outwards preserving innerBounds"
	| c |  
	c := self center.
	super borderWidth: anInteger.
	super extent: self defaultExtent.
	self center: c.! !

!Arrow methodsFor: 'defaults' stamp: 'ArtyomSemikov 11/20/2011 21:26'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!Arrow methodsFor: 'defaults' stamp: 'ArtyomSemikov 11/20/2011 21:25'!
defaultColor
	^ Color black! !

!Arrow methodsFor: 'accessing' stamp: 'ArtyomSemikov 11/20/2011 20:40'!
drow 
^drow ! !

!Arrow methodsFor: 't-rotating' stamp: ''!
forwardDirection
	"Return the receiver's forward direction (in eToy terms)"
	^self valueOfProperty: #forwardDirection ifAbsent:[0.0]! !

!Arrow methodsFor: 't-rotating' stamp: ''!
forwardDirection: newDirection
	"Set the receiver's forward direction (in eToy terms)"
	self setProperty: #forwardDirection toValue: newDirection.! !

!Arrow methodsFor: 'events-processing' stamp: 'ArtyomSemikov 11/20/2011 20:50'!
handleKeystroke: anEvent
	| keyValue |
	keyValue := anEvent keyValue.
	keyValue = 30
		ifTrue: [ 
			self position: self position - (0 @ 1 * Stage Speed).
			startarrow position: startarrow position + (0 @ 1 * Stage Speed).
			drow
				ifTrue: [ self ArrowEndSize: 30 @ 30 position: 10 @ 10 + (0 @ 1 * Stage Speed) ].
			Stage DontMoov: 0 @ -1 * Stage Speed ].
	keyValue = 28
		ifTrue: [ 
			self position: self position - ((Stage Speed * 1) @ 0).
			startarrow position: startarrow position + ((Stage Speed * 1) @ 0).
			drow
				ifTrue: [ self ArrowEndSize: 30 @ 30 position: 10 @ 10 + ((Stage Speed * 1) @ 0) ].
			Stage DontMoov: (Stage Speed * -1) @ 0 ].
	keyValue = 31
		ifTrue: [ 
			self position: self position + (0 @ 1 * Stage Speed).
			startarrow position: startarrow position - (0 @ 1 * Stage Speed).
			drow
				ifTrue: [ self ArrowEndSize: 30 @ 30 position: 10 @ 10 - (0 @ 1 * Stage Speed) ].
			Stage DontMoov: 0 @ 1 * Stage Speed ].
	keyValue = 29
		ifTrue: [ 
			self position: self position + ((Stage Speed * 1) @ 0).
			startarrow position: startarrow position - ((Stage Speed * 1) @ 0).
			drow
				ifTrue: [ self ArrowEndSize: 30 @ 30 position: 10 @ 10 - ((Stage Speed * 1) @ 0) ].
			Stage DontMoov: (Stage Speed * 1) @ 0 ].
	keyValue = $a asciiValue
		ifTrue: [ 
			drow
				ifTrue: [ drow := false ]
				ifFalse: [ drow := true ] ]! !

!Arrow methodsFor: 't-rotating' stamp: 'ArtyomSemikov 11/20/2011 21:46'!
heading
	"Return the receiver's heading"
	^ self owner 
		ifNil: [self forwardDirection]
		ifNotNil: [self forwardDirection + self owner degreesOfFlex]! !

!Arrow methodsFor: 'initialization' stamp: 'ArtyomSemikov 11/20/2011 22:16'!
initialize
super initialize.
color := Color red.
self Start.
drow :=false.
bounds := 0 @ 0 extent: (50 @ 50).! !

!Arrow methodsFor: 't-rotating' stamp: ''!
prepareForRotating
	"If I require a flex shell to rotate,
	then wrap it in one and return it.
	Polygons, eg, may override to do nothing."

	^ self addFlexShell! !

!Arrow methodsFor: 't-rotating' stamp: 'ArtyomSemikov 11/20/2011 21:40'!
rotationDegrees
	"Default implementation."

	^ 0.0
! !

!Arrow methodsFor: 't-rotating' stamp: ''!
rotationDegrees: degrees	
	"redefined in all morphs which are using myself"! !

!Arrow methodsFor: 't-rotating' stamp: 'ArtyomSemikov 11/20/2011 21:49'!
setDirectionFrom: aPoint
	| delta degrees |
	delta := (self transformFromWorld globalPointToLocal: aPoint) - self referencePosition.
	degrees := delta degrees + 90.0.
	self forwardDirection:(degrees \\ 360) rounded.
! !

!Arrow methodsFor: 'stepping and presenter' stamp: 'ArtyomSemikov 11/20/2011 19:05'!
step
	self changed! !

!Arrow methodsFor: 'testing' stamp: 'ArtyomSemikov 11/20/2011 19:05'!
stepTime
	^ 0! !

BorderedMorph subclass: #ArrowEnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Esse'!

!ArrowEnd methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 19:32'!
Size:aSize
bounds := 0 @ 0 extent:aSize.! !

!ArrowEnd methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 21:29'!
borderWidth: anInteger
	"Grow outwards preserving innerBounds"
	| c |  
	c := self center.
	super borderWidth: anInteger.
	super extent: self defaultExtent.
	self center: c.! !

!ArrowEnd methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 21:29'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!ArrowEnd methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 21:28'!
defaultColor
	^ Color black! !

!ArrowEnd methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 19:33'!
initialize
super initialize.
color := Color red.
bounds := 0 @ 0 extent: (50 @ 50).! !

BorderedMorph subclass: #Camera
	instanceVariableNames: 'magnification trackPointer srcExtent showPointer look speed'
	classVariableNames: 'RecursionLock'
	poolDictionaries: ''
	category: 'Esse'!

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 02:43'!
borderWidth: anInteger
	"Grow outwards preserving innerBounds"
	| c |  
	c := self center.
	super borderWidth: anInteger.
	super extent: self defaultExtent.
	self center: c.! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 02:45'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 02:40'!
defaultColor
	^ Color black! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 02:48'!
defaultExtent
	^(srcExtent * magnification) truncated + (2 * borderWidth)! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 02:46'!
drawOn: aCanvas
	super drawOn: aCanvas.		"border and fill"
	aCanvas isShadowDrawing ifFalse: [
		"Optimize because #magnifiedForm is expensive"
		aCanvas paintImage: self magnifiedForm at: self innerBounds origin]! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 02:48'!
extent: aPoint
	"Round to multiples of magnification"
	srcExtent := (aPoint - (2 * borderWidth)) // magnification.
	^super extent: self defaultExtent! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/20/2011 18:39'!
handleKeystroke: anEvent
| keyValue |
keyValue := anEvent keyValue.
keyValue =30
ifTrue: [look:= self look - (0@1*self speed )].
keyValue = 28
ifTrue: [look:= self look - (self speed*1@0)].
keyValue = 31
ifTrue: [look:= self look +(0@1*self speed)].
keyValue =29
ifTrue: [look:= self look +(self speed*1@0)].
keyValue = $, asciiValue
ifTrue: [ self speed >1 ifTrue:[speed:=self speed -1]  ].
keyValue = $. asciiValue
ifTrue: [speed:=self speed +1].
keyValue = $- asciiValue
ifTrue: [ self magnification >1 ifTrue:[ magnification:=self magnification -0.01]  ].
keyValue = $= asciiValue
ifTrue: [magnification:= self magnification +0.01 ].! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 16:25'!
initialize
	"initialize the state of the receiver"
	super initialize.

	trackPointer := true.
	showPointer := false.
	magnification := 1.
look:=100@100.
speed:=2 .
	self extent: 128 @ 128! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 03:10'!
look 
^look! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 03:10'!
look:aPoint
look:=aPoint ! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 16:24'!
magnification 
^magnification ! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 16:25'!
magnification:aMagnification
magnification:=aMagnification ! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 02:57'!
magnifiedForm
	"Answer the magnified form"
	| srcRect form magnified |
	srcRect := self sourceRectFrom: self sourcePoint.
	(RecursionLock isNil and: [ self showPointer or: [ srcRect intersects: self bounds ]])
		ifTrue: [RecursionLock := self.
			form := self currentWorld
						patchAt: srcRect
						without: self
						andNothingAbove: false.
			RecursionLock := nil]
		ifFalse: ["cheaper method if the source is not occluded"
			form := Display copy: srcRect].
	"smooth if non-integer scale"
	magnified := form
				magnify: form boundingBox
				by: magnification
				smoothing: (magnification isInteger
						ifTrue: [1]
						ifFalse: [2]).
	"display the pointer rectangle if desired"
	self showPointer
		ifTrue: [magnified
				reverse: (magnified center - (2 @ 2) extent: 4 @ 4)
				fillColor: Color white].
	^ magnified! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 03:04'!
showPointer
	^showPointer ifNil: [ showPointer := false ].! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 03:08'!
sourcePoint
	^look
		! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 03:03'!
sourceRect
	^self sourceRectFrom: self sourcePoint
! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 02:53'!
sourceRectFrom: aPoint
	^ (aPoint extent: srcExtent) translateBy: (srcExtent // -2) + 1.
! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 03:22'!
speed 
^speed ! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 03:23'!
speed:aSpeed 
speed:=aSpeed ! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 03:04'!
step
	self changed! !

!Camera methodsFor: 'as yet unclassified' stamp: 'ArtyomSemikov 11/19/2011 03:05'!
stepTime
	^ 0! !
